% Create densities

costvector=[0.01 0.03 0.05 0.1 0.2 0.3 0.4 0.5]; % cost parameter values (make sure that policies for these values have been saved)
phivector=[0.1 0.3 0.5 0.7 1]; % list here those entry cost values for which densities should be computed

resultdir='policies/';  %directory for reading policies from
densitydir='densities/'; % directory for saving densitydata


% Iteration parameters
iternumdensity=10000; % maximum number of iterations
density_tol=1e-10; % stopping criterium for difference between two successive iterations

zinit=1; % Initial productivity (normalization)


for costind=1:length(costvector);
    cost=costvector(costind);
    % File names for the policies:
    alku=num2str(cost); % Prefix for the file names
    
    loppu=''; % Postfix for the file names
    
    xgridFIX=load([resultdir,alku,'xvector',loppu]);
    sgridFIX=load([resultdir,alku,'svector',loppu]);
    VFIX=load([resultdir,alku,'valuematrix',loppu]);
    polFIX=load([resultdir,alku,'polmatrix',loppu]);
    params=load([resultdir,alku,'params',loppu]);
%    [Tl,Td,pol,xgrid,sgrid,V]=MakeTrans(params,pol,xgrid,sgrid,V);
    
    
    for phiind=1:length(phivector),
        entrycost=phivector(phiind);
        
        loppunimi=num2str(entrycost); %postfix for file names
        
%        [BirthVector price]=FindBirth(params,entrycost,zinit,pol,xgrid,sgrid,V);
        [Tl,Td,pol,xgrid,sgrid,V,BirthVector,price]=MakeTransAllowTail(params,polFIX,xgridFIX,sgridFIX,VFIX,entrycost,zinit);
        
        if price>0,
            [density zmean smean turnover issuerate]=FindDensity(params,xgrid,sgrid,pol,Tl,Td,BirthVector,price,iternumdensity,density_tol);
        else
            density=zeros(length(sgrid),length(xgrid));
            zmean=0;
            smean=0;
            turnover=0;
            issuerate=0;
        end
        
        
       


        zgrid=exp(xgrid)./price; % This is the grid for productivity

        [price_unc zmean_unc turnover_unc density_unc zgrid_unc]=ComputeUnc(params,entrycost,zinit);
        
        
        save([densitydir,alku,'price',loppunimi],'price','-ascii');
        save([densitydir,alku,'density',loppunimi],'density','-ascii');
        save([densitydir,alku,'zmean',loppunimi],'zmean','-ascii');
        save([densitydir,alku,'smean',loppunimi],'smean','-ascii');
        save([densitydir,alku,'turnover',loppunimi],'turnover','-ascii');
        save([densitydir,alku,'issuerate',loppunimi],'issuerate','-ascii');
        save([densitydir,alku,'zgrid',loppunimi],'zgrid','-ascii');
        save([densitydir,alku,'price_unc',loppunimi],'price_unc','-ascii');
        save([densitydir,alku,'zmean_unc',loppunimi],'zmean_unc','-ascii');
        save([densitydir,alku,'turnover_unc',loppunimi],'turnover_unc','-ascii');
        save([densitydir,alku,'density_unc',loppunimi],'density_unc','-ascii');
        save([densitydir,alku,'zgrid_unc',loppunimi],'zgrid_unc','-ascii');

    end
   
end
%Draw policy
%figure;
%ygrid=exp(xgrid);
%pcolor(ygrid-cost,sgrid,pol);zoom on;

