function [params,xgrid,sgrid,V,pol]=fun(r,rho,lambda,alpha,sigma,xgridinit,sgridinit,Vinit,divlumpratio,iternum,dvmax,iterfine,fineratio,resultdir,alku,loppu,ksi,gamma,cost);

params=[alpha,sigma,r,rho,lambda,cost,ksi,gamma];
xgrid=xgridinit;sgrid=sgridinit;

%First run
dx=xgrid(2)-xgrid(1);
ds=sgrid(2)-sgrid(1);
divlump=ds/divlumpratio;
XN=size(xgrid,2);SN=size(sgrid,2);xmax=xgrid(XN);smax=sgrid(SN);

%unconstrained exit threshold (y~GBM(alpha,sigma))
beta=1/2-alpha/(sigma^2)-sqrt((alpha/(sigma^2)-1/2)^2+2*(rho+lambda)/(sigma^2));
ystar=(beta/(beta-1))*((rho+lambda)-alpha)*(cost/(rho+lambda));
xmin=log(ystar)

% Call the program:
tnow=cputime; %initialize clock
[V,pol]=liquidgbm(r,rho,lambda,alpha,sigma,iternum,dvmax,divlump,xgrid,sgrid,Vinit,resultdir,alku,loppu,ksi,gamma,cost);
itertime=cputime-tnow %cpu-time taken by the algorithm
%clocknow=clock; % current time

% Make vectors smaller
xx=XN;ss=SN;
for xind=1:XN,
    if min(pol(:,xind))<2,
        xx=xind;
    end
end
xx=min(XN,xx+11);
for sind=1:SN,
    if min((pol(sind,:)-1).^2)==0,
        ss=sind;
    end
end
ss=min(SN,ss+11);
xgrid=xgrid(1:xx);
sgrid=sgrid(1:ss);
pol=pol(1:ss,1:xx);
V=V(1:ss,1:xx);
XN=size(xgrid,2);SN=size(sgrid,2);
xmax=xgrid(XN);smax=sgrid(SN);

Vold=V;polold=pol;xgridold=xgrid;sgridold=sgrid;



% Finer grid:
for iter=1:iterfine,
    dx=dx/fineratio;ds=ds/fineratio;
    divlump=ds/divlumpratio;
    
    % XGrid
    xgrid=(-(ceil(-xgridold(1)/dx))*dx:dx:xmax); % Include x=0 in the grid!
    XN=size(xgrid,2);
%    xzeroind=1;for xind=1:XN,if xgrid(xind)<=0,xzeroind=xind;end;end 
    
    % SGrid
    sgrid=(0:ds:smax+ds);
    SN=size(sgrid,2);
    

    % make sure that all gridpoints in the new grid are within the support of the previous grid
    while xgrid(1)<xgridold(1),
        xgrid=xgrid(2:XN);
        XN=XN-1;
%        xzeroind=xzeroind+1;
    end
    while xgrid(XN)>xgridold(size(xgridold,2)),
        xgrid=xgrid(1:XN-1);
        XN=XN-1;
    end
    while sgrid(SN)>sgridold(size(sgridold,2)),
        sgrid=sgrid(1:SN-1);
        SN=SN-1;
    end
    
    %Use V of previous round as initial value for computation 

    Vinit=interp2(xgridold',sgridold',Vold,xgrid,sgrid');
    
    tnow=cputime; %initialize clock
    [V,pol]=liquidgbm(r,rho,lambda,alpha,sigma,iternum,dvmax,divlump,xgrid,sgrid,Vinit,resultdir,alku,loppu,ksi,gamma,cost);
    itertime=cputime-tnow %cpu-time taken by the algorithm
    
    
    % Make vectors smaller
    xx=XN;ss=SN;
    for xind=1:XN,
        if min(pol(:,xind))<2,
            xx=xind;
        end
    end
    xx=min(XN,xx+11);
    for sind=1:SN,
        if min((pol(sind,:)-1).^2)==0,
            ss=sind;
        end
    end
    ss=min(SN,ss+11);
    xgrid=xgrid(1:xx);
    sgrid=sgrid(1:ss);
    pol=pol(1:ss,1:xx);
    V=V(1:ss,1:xx);
    
    
    Vold=V;polold=pol;xgridold=xgrid;sgridold=sgrid;
end





%close all;
%figure;
%ygrid=exp(xgrid);
%pcolor(ygrid,sgrid,pol);zoom on;


